var filename;
var dirname;
var pref;
var strbundle;

function load() {
	pref = Components.classes['@mozilla.org/preferences-service;1'].getService(Components.interfaces.nsIPrefBranch);
	filename = document.getElementById("filename");
	dirname = document.getElementById("dirname");
	strbundle = document.getElementById("strings");

	try {
		var filenaming = pref.getCharPref("extensions.dta.rename.files");
		var dirnaming = pref.getCharPref("extensions.dta.rename.dir");
	} catch (e) {
		var filenaming = "*name*.*ext*";
		var dirnaming = "";
		pref.setCharPref("extensions.dta.rename.files", filenaming);
		pref.setCharPref("extensions.dta.rename.dir", "");
	}
	
	filename.value = filenaming;
	dirname.value = dirnaming;
	
	aggiornaEs();
}

function alertCheck(num) {

	var promptService = Components.classes["@mozilla.org/embedcomp/prompt-service;1"].getService(Components.interfaces.nsIPromptService);
	var checkResult = {};
	
	try {
		if (!pref.getBoolPref("extensions.dta.rename.noalert"+num)) {
		
			promptService.alertCheck(window, strbundle.getString("renameerror"), strbundle.getString("alert"+num), strbundle.getString("dontshow"), checkResult);
		
			if (checkResult.value) 
				pref.setBoolPref("extensions.dta.rename.noalert"+num, true);
				
		}
	} catch (e) {
		promptService.alertCheck(window, strbundle.getString("renameerror"), strbundle.getString("alert"+num), strbundle.getString("dontshow"), checkResult);
		
		if (checkResult.value) 
			pref.setBoolPref("extensions.dta.rename.noalert"+num, true);
	}
}

function confirmCheck(num) {	

	var promptService = Components.classes["@mozilla.org/embedcomp/prompt-service;1"].getService(Components.interfaces.nsIPromptService);
	var checkResult = {};
	
	try {
		if (!pref.getBoolPref("extensions.dta.rename.noalert"+num)) {
		
			if (promptService.confirmCheck(window, strbundle.getString("renameerror"), strbundle.getString("alert"+num), strbundle.getString("dontshow"), checkResult))
				filename.value = "*name*.*ext*";
			
			if (checkResult.value) 
				pref.setBoolPref("extensions.dta.rename.noalert"+num, true);
				
		}
	} catch (e) {
		if (promptService.confirmCheck(window, strbundle.getString("renameerror"), strbundle.getString("alert"+num), strbundle.getString("dontshow"), checkResult))
			filename.value = "*name*.*ext*";
		
		if (checkResult.value) 
			pref.setBoolPref("extensions.dta.rename.noalert"+num, true);
	}
}

function controlRename() {
	
	if (filename.value.length == filename.value.replace(/\*/gi, "").length) {
		alertCheck(4);
		filename.value = "*name*.*ext*";
		aggiornaEs();
	} else if (filename.value.length - filename.value.replace(/\*text\*/gi, "ttextt").replace(/\*/gi, "").length < 2) {
		alertCheck(1);	
		filename.value = "*name*.*ext*";
		aggiornaEs();
	}	else if ((filename.value.length - filename.value.replace(/\*/gi, "").length) % 2 != 0) {
		confirmCheck(3);	
		aggiornaEs();
	}	else if (filename.value.length - filename.value.replace(/\*name\*/gi, "ttttt").replace(/\*ext\*/gi, "tttt").length < 2) {
		confirmCheck(2);	
		aggiornaEs();
	}
	
}

function aggiornaEs() {

	var file = strbundle.getString("example") + " " + filename.value.replace(/\*name\*/gi, "mywork").replace(/\*ext\*/gi, "rtf").
	replace(/\*url\*/gi, "www.mysite.com").replace(/\*curl\*/gi, "www.mysite.com-mysub-subdir").replace(/\*subdirs\*/gi, "mysub-subdir").
	replace(/\*num\*/gi, "021").replace(/\*hh\*/gi, "08").replace(/\*mm\*/gi, "35").replace(/\*ss\*/gi, "20").
	replace(/\*text\*/gi, "This is my document").replace(/\*d\*/gi, "21").replace(/\*m\*/gi, "10").replace(/\*y\*/gi, "2005");
	
	file = file.replace(/(\\){1,}/g, "_").replace(/(\/){1,}/g, "_");
	document.getElementById("esfile").value = toggleInvalidChar(file);
	
	if (dirname.value.length > 0) {
		var dir =  strbundle.getString("example") + " ..." + findSeparator() + dirname.value.replace(/\*name\*/gi, "mywork").
		replace(/\*ext\*/gi, "rtf").replace(/\*url\*/gi, "www.mysite.com").replace(/\*curl\*/gi, "www.mysite.com"+findSeparator()+"mysub"+findSeparator()+"mysubdir").
		replace(/\*subdirs\*/gi, "mysub"+findSeparator()+"subdir").replace(/\*num\*/gi, "021").replace(/\*hh\*/gi, "08").
		replace(/\*mm\*/gi, "35").replace(/\*ss\*/gi, "20").replace(/\*d\*/gi, "21").replace(/\*text\*/gi, "This is my document").
		replace(/\*m\*/gi, "10").replace(/\*y\*/gi, "2005") + findSeparator();
		dir = dir.replace(/\\/g, findSeparator()).replace(/\//g, findSeparator()).replace(/(\\){1,}/g, findSeparator()).replace(/(\/){1,}/g, findSeparator());
		document.getElementById("esdir").value = toggleInvalidChar(dir);
	} else
		document.getElementById("esdir").value = strbundle.getString("nosubdir");
		
}

function savePrefs() {
	if (dirname.value.substring(0,1) == "/") dirname.value = dirname.value.substring(1, dirname.value.length);
		if (dirname.value.substr(dirname.value.length - 1, 1) == "/") dirname.value = dirname.value.substring(0, dirname.value.length -1);
		
	pref.setCharPref("extensions.dta.rename.files", filename.value);
	pref.setCharPref("extensions.dta.rename.dir", dirname.value);
}

function toggleInvalidChar(filename) {
	try{
		filename = filename.replace(/\?/g, "_").replace(/\+/g, "_").replace(/&/g, "_").replace(/=/g, "_").replace(/:/g, "_").replace(/</g, "_").replace(/>/g, "_").replace(/%20/g, " ").replace(/%2520/g, " ").replace(/\*/g, "_").replace(/\|/g, "_").replace(/"/g, "");
		return filename;
	} catch(e) {
		return "";
	}
}

function findSeparator() {

	const DIR_SERVICE = new Components.Constructor("@mozilla.org/file/directory_service;1","nsIProperties");
	try {
		var path=(new DIR_SERVICE()).get("ProfD", Components.interfaces.nsIFile).path;
	} catch (e) {}

	// determine the file-separator
	if (path.search(/\\/) != -1) return "\\"; else return "/";
}
